#pragma once

template <typename  T> class vector {
    T * mData;
    size_t mCapacity;
    size_t mSize;

    void increaseCapacity() {
        mCapacity *= 2;
        T *data = new T[mCapacity];
        for (size_t i = 0; i < mSize; i++) {
            data[i] = mData[i];
        }
        delete[] mData;
        mData = data;
    }
public:
    vector(size_t capacity = 16) : mData(new T[capacity]), mCapacity(capacity), mSize(0) {
        printf("Called regular constructor\n");
    }

    template <typename ST = T> vector(const vector<ST> & src) : mData(new T[src.size()]), mSize(src.size()) {
        for (size_t i = 0; i < mSize; i++) {
            mData[i] = src[i];
        }
        printf("Called conversion constructor\n");
    }

    vector(const vector & src) : mData(new T[src.mCapacity]), mCapacity(src.mCapacity), mSize(src.mSize) {
        for (size_t i = 0; i < mSize; i++) {
            mData[i] = src.mData[i];
        }
        printf("Called copy constructor\n");
    }

    vector & operator=(const vector & src) { // copy-assignment operator
        if (mCapacity < src.mSize) {
            delete [] mData;
            mData = new T[src.mSize];
            mCapacity = src.mSize;
        }

        mSize = src.mSize;
        for (size_t i = 0; i < mSize; i++) {
            mData[i] = src.mData[i];
        }
        printf("Called copy-assignment operator\n");
        return *this;
    }

    void push_back(const T & value) {
        if (mCapacity == mSize) increaseCapacity();
        mData[mSize++] = value;
    }

    T& at(size_t index) {
        return mData[index];
    }

    const T & at(size_t index) const { // supraincarcare pentru obiecte const - metoda este const-qualified
        return mData[index];
    }

    T & operator[](size_t index) {
        return mData[index];
    }

    const T & operator[](size_t index) const {
        return mData[index];
    }

    size_t size() const { // metoda este const-qualified si apelul ei nu modifica obiectul
        return mSize;
    }
    ~vector() {
        delete[] mData;
        printf("Called destructor\n");
    }
};


