#include <cstring>
#include <iostream>
#include "Vector.hpp"

enum Gender {
    FEMALE,
    MALE,
    UNKNOWN
};

enum StudyType {
    UNDERGRAD,
    MASTER,
    PHD
};

struct Room {
    char building[32];
    uint8_t floor;
    uint16_t roomNo;
    uint8_t spots;
    Gender assignedGender;

    Room(const char building[], uint8_t floor, uint16_t roomNo, uint8_t spots, Gender assignedGender) {
        strcpy(this->building, building);
        this->floor = floor;
        this->roomNo = roomNo;
        this->spots = spots;
        this->assignedGender = assignedGender;
    }

    Room() {

    }
};

struct StudyYear {
private:
    StudyType type;
    uint8_t year;

public:
    StudyYear(StudyType type, uint8_t year) {
        this->type = type;

        if (type == UNDERGRAD && year > 4 ||
            type == MASTER && year > 2) {
            printf("Eroare...\n");
            this->year = 1;
        } else {
            this->year = year;
        }

    }

    StudyYear(){}

    void setYear(int year) {
        if (type == UNDERGRAD && year > 4 ||
            type == MASTER && year > 2) {
            printf("Eroare...\n");
            } else {
                this->year = year;
            }
    }

    uint8_t getYear() {
        return year;
    }
};

struct Address {
    char country[32];
    char county[32];
    char city[32];
    char street[128];
    char number[32];

    Address(const char country[], const char county[], const char city[], const char street[], const char number[]) {
        strcpy(this->country, country);
        strcpy(this->county, county);
        strcpy(this->city, city);
        strcpy(this->street, street);
        strcpy(this->number, number);
    }

    Address() = default;
    // Address() {}
};

struct Student {
    char name[128];
    Room roomPreference;
    double grade;
    StudyYear studyYear;
    Gender gender;
    Address address;

    Student(const char name[], Room roomPreference, StudyYear studyYear, double grade, Gender gender, Address address) :
    roomPreference(roomPreference), studyYear(studyYear), grade(grade), gender(gender), address(address){
        strcpy(this->name, name); // Student *
    }

    Student() {}

    bool isEligible() {
        return strcmp(address.city, "Bucharest") != 0 && strcmp(address.county, "Ilfov") != 0;
    }
};

void printName(const Student & student) {
    printf("%s", student.name);
}

template <typename T, typename R = T> R sumAll(const vector<T> & v) {
    R sum{};
    for (size_t i = 0; i < v.size(); i++) {
        sum += v.at(i);
    }
    return sum;
}

// std::string sumAll(const vector<char> & v) {
//     std::string sum;
//     for (size_t i = 0; i < v.size(); i++) {
//         sum += v.at(i);
//     }
//     return sum;
// }

template <typename ST, typename DT> vector<DT> convert(const vector<ST> & src) {
    vector<DT> dst;
    for (size_t i = 0; i < src.size(); i++) {
        dst.push_back(src[i]);
    }
    return dst;
}

int main() {
    Student firstStudent(
        "Ion Ion",
        Room("LeuA", 3, 308, 2, Gender::MALE),
        StudyYear(UNDERGRAD, 2),
        9.89,
        MALE,
        Address("Romania", "Sector2", "Bucharest", "Strada fara nume", "4-6")
        ); // se apeleaza constructorul fara argumente

    // Student newStudent(3, 4, 3); //apel de construcot
    // Student newStudent2(int a, int b, int c); // prototip de functie

    Student newStudent3; // apel al construtorului fara argumente

    // strcpy(firstStudent.name, "Ion Ion");
    // strcpy(firstStudent.address.city, "Bucharest");
    // strcpy(firstStudent.address.county, "Sector 2");
    // strcpy(firstStudent.roomPreference.building, "LeuA");
    // firstStudent.roomPreference.floor = 3;
    // firstStudent.roomPreference.roomNo = 308;
    // // firstStudent.roomPreference.spots = 2;
    // // firstStudent.gender = MALE;
    // // firstStudent.studyYear.type = UNDERGRAD;
    // // firstStudent.studyYear.year = 2;
    //
    // printName(firstStudent);
    // firstStudent.isEligible();
    //
    // Student secondStudent(
    //     "Ioana Ioana",
    //     Room("LeuA", 3, 309, 2, Gender::MALE),
    //     StudyYear(UNDERGRAD, 2),
    //     9.91,
    //     FEMALE,
    //     Address("Romania", "Gorj", "Targu Jiu", "Strada fara nume", "4-6")
    //     );
    // // secondStudent.isEligible();
    // // strcpy(secondStudent.name, "Ioana Ioana");
    // // strcpy(secondStudent.address.city, "Targu Jiu");
    // // strcpy(secondStudent.address.county, "Gorj");
    //
    // printf("Student 1 is eligible: %d\n", firstStudent.isEligible());
    // printf("Student 2 is eligible: %d\n", secondStudent.isEligible());
    //
    // StudyYear s2(MASTER, 2);
    // s2.setYear(100);
    // printf("Year is: %hhu", s2.getYear());


    // for (int i = 0; i < 10; i++) {
    //     vector myVector;
    //
    //     for (int i = 0; i < 100000000; i++) myVector.push_back(i);
    //
    //     // for (size_t i = 0; i < myVector.size(); i++) {
    //     //     printf("vector[%lu] -> %d\n", i, myVector.at(i));
    //     // }
    //     getchar();
    // }
    //
    // vector * heapAllocatedVector = new vector(100);
    //
    // heapAllocatedVector->push_back(1);
    //
    // delete heapAllocatedVector;

    vector<int> v1(32);
    v1.push_back(1);
    v1.push_back(4);
    v1[0] = 2;
    v1.push_back(15);

    printf("Sum of all int elements is: %d\n", sumAll(v1));
    vector<int> v2 = v1; // se apeleaza constructorul de copiere
    vector<int> v3;
    v3 = v1; // nu se apeleaza constructul de copiere, ci se foloseste copy-assignment operator
    v3[0] = 1;

    // v2.at(0) = 2;
    //
    // vector v3(v1);
    //
    // printf("v1[0] = %d, v2[0] = %d\n", v1.at(0), v2.at(0));

    int i = 10;
    int j = (i = 12);

    vector<double> vDouble;
    vDouble.push_back(1.5);
    vDouble.push_back(2.5);
    printf("%lf\n", vDouble[0]);
    printf("Sum of double int elements is: %lf\n", sumAll(vDouble));

    vector<char> str;
    str.push_back('A');
    str.push_back('n');
    str.push_back('a');
    str.push_back(' ');
    str.push_back('a');
    str.push_back('r');
    str.push_back('e');

    std::string concat = sumAll<char, std::string>(str);
    printf("String: %s\n", concat.c_str());

    vector<int> vector4 = convert<double, int>(vDouble);
    printf("%d, %d\n", vector4[0], vector4[1]);
    return 0;
}